# AI_A002 - Aspect factory must contain factory method
---
This error occurs when the aspect class uses Factory but Factory class does not have proper factory method.

Example of valid aspect class definition and factory class definition:
```c#
[Aspect(Scope.Global, Factory = typeof(MyFactory))]
public class MyAspect
{
  //advices
}

public class MyFactory
{
  public static object GetInstance(Type type)
  {
    // return aspect instance
  }
}

```
