# AI_A003 - Aspect must have public parameterless constructor or factory
---
This error occurs when the aspect class does not have parameterless constructor nand defined factory.
Aspect class instances need a way to be instantinated. So they should either have parameterless constructor:
```c#
[Aspect(Scope.Global)]
public class MyAspect
{
  public MyAspect()
  {
  }
  //advices
}
```
... or factory:
```c#
[Aspect(Scope.Global, Factory = typeof(MyFactory))]
public class MyAspect
{
  public MyAspect(ILogger logger)
  {
  }
  //advices
}
```
